﻿using FarPoint.Win.Spread;
using FarPoint.Win.Spread.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace test_header
{
    public partial class Form1 : Form
    {
        DefaultSheetDataModel dataModel = new DefaultSheetDataModel();

        public Form1()
        {
            InitializeComponent();

            richTextBox1.Text = File.ReadAllText("datasource.xml");
            fpSpread1.AllowColumnMove = true;
        }

        void Fill_Table()
        {
            DataTable data_table = new DataTable("name");
            data_table.Columns.Add("update_time");
            data_table.Columns.Add("ret");
            data_table.Columns.Add("sup");
            data_table.Columns.Add("setp");
            data_table.Columns.Add("mode");
            data_table.Columns.Add("alarms");
            data_table.Columns.Add("curra");
            data_table.Columns.Add("currb");
            data_table.Columns.Add("currc");
            data_table.Columns.Add("connect_time");
            data_table.Columns.Add("time_now");

            XmlReader reader = XmlReader.Create(new StringReader(richTextBox1.Text));
            XmlDocument doc = new XmlDocument();
            doc.Load(reader);
            reader.Close();

            XmlNodeList items_list = doc.SelectNodes("/items_list/item");

            for (int i = 0; i < items_list.Count; i++)
            {
                XmlNode xn = items_list.Item(i);

                string item_id = items_list[i].Attributes["item_id"].Value;

                double? ret_1 = null;
                if (xn["ret_1"] != null)
                    ret_1 = Convert.ToDouble(xn["ret_1"].InnerText) / 100;
                
                double? sup_1 = null;
                if (xn["sup_1"] != null)
                    sup_1 = Convert.ToDouble(xn["sup_1"].InnerText) / 100;
                
                double? setp = null;
                if (xn["setp"] != null)
                    setp = Convert.ToDouble(xn["setp"].InnerText) / 100;
                
                string mode = "---";
                if (xn["mode"] != null)
                    mode = xn["mode"].InnerText;
                
                string alarms = "------";
                if (xn["alarms"] != null)
                    alarms = xn["alarms"].LastChild.InnerText;
                
                double? curra = null;
                 if (xn["current_a"] != null)
                    curra = Convert.ToDouble(xn["current_a"].InnerText) / 100;
                 double? currb = null;
                 if (xn["current_b"] != null)
                     currb = Convert.ToDouble(xn["current_b"].InnerText) / 100;
                 double? currc = null;
                 if (xn["current_c"] != null)
                     currc = Convert.ToDouble(xn["current_c"].InnerText) / 100;

                string connect_time = "---";
                //DateTime? connect_time = null; 
                if (xn["connect_time"] != null)
                {
                    //DateTime dt;
                    //DateTime.TryParse(xn["connect_time"].InnerText, out dt);
                    //connect_time = dt;
                    connect_time = xn["connect_time"].InnerText;
                }

                string time_now = "---";
                //DateTime? time_now = null;
                data_table.Rows.Add(item_id, ret_1, sup_1, setp, mode, alarms, curra, currb, currc, connect_time, time_now);
            }
            DataSet data_set = new DataSet();
            data_set.Tables.Add(data_table);
           
            dataModel.DataSource = data_set;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Fill_Table();
            fpSpread1.Sheets[0].Models.Data = dataModel;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Fill_Table();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.Columns[10].Formula = textBox1.Text;
        }

        private void fpSpread1_CellClick(object sender, CellClickEventArgs e)
        {
            int i = e.Row;
            int j = e.Column;
            if (j == 10)
                MessageBox.Show(fpSpread1.ActiveSheet.Columns[10].Formula);
        }
    }
}
